﻿--- This manages options, databases, etc.
local Broker_H3S = LibStub("AceAddon-3.0"):NewAddon("H3 Skills",
											'AceTimer-3.0')

--- This manages all LDB related things.
local H3S_Object = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_H3Skills", {type = "data source", icon = select(3, GetSpellInfo(8613)), label = "H3 Skills"})

--- This will be used incase we need something to update constantly without anything disabling/enabling it.
local H3S = CreateFrame("Frame", "Broker_H3Skills")

--- Used to manage tooltip toggling
local H3S_2 = CreateFrame("Frame", "Broker_H3Skills")

--- Obviously no the database. >.>
local db -- divisor dividend modulusRemainder eightbitNum redNum greenNum blueNum

--- databases and locales
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale("Broker_H3Skills")
local LibQTip = LibStub("LibQTip-1.0")

--- Local Variables
local totaltime2, elapsed2, elapsed, elap = 0, 0, 0, 0
local TOTALTIME = 20
local tooltip


--- Tradeskill Cooldowns ---
-- This section is for defining the cooldown in seconds for various skills. This makes things like color gradients easier to do.
local TradeCD = {}

	--- Item Cooldowns ---
	TradeCD[44717] = 590400		--- Disgusting Jar <From Ripe Jar: ID 44718>
	TradeCD[39878] = 590400		--- Mysterious Egg <From Cracked Egg: ID 39883>

	--- Transmute Cooldowns and 20 hour CDs ---
	--JC--
	TradeCD[47280] = 72000		--- Brilliant Glass
	TradeCD[62242] = 72000		--- Icy Prism
	TradeCD[66658] = 72000		--- Ametrine
	TradeCD[66659] = 72000		--- Cardinal Ruby
	TradeCD[66662] = 72000		--- Dreadstone
	TradeCD[66664] = 72000		--- Eye of Zul
	TradeCD[66660] = 72000		--- King's Amber
	TradeCD[66663] = 72000		--- Majestic Zircon
	TradeCD[61288] = 72000		--- Minor Glyph RS
	TradeCD[61177] = 72000		--- Major Glyph RS

	--Alch--
	TradeCD[11479] = 72000		--- Iron --> Gold
	TradeCD[11480] = 72000		--- Mithril --> Truesilver
	TradeCD[17559] = 72000		--- Air --> Fire
	TradeCD[17566] = 72000		--- Earth --> Life
	TradeCD[17561] = 72000		--- Earth --> Water
	TradeCD[17560] = 72000		--- Fire --> Earth
	TradeCD[17565] = 72000		--- Life --> Earth
	TradeCD[17563] = 72000		--- Undeath --> Earth
	TradeCD[17562] = 72000		--- Water --> Air
	TradeCD[17564] = 72000		--- Water --> Undeath
	TradeCD[28566] = 72000		--- Primal Air --> Fire
	TradeCD[28585] = 72000		--- Primal Earth --> Life
	TradeCD[28567] = 72000		--- Primal Earth --> Water
	TradeCD[28568] = 72000		--- Primal Fire --> Earth
	TradeCD[28583] = 72000		--- Primal Fire --> Mana
	TradeCD[28584] = 72000		--- Primal Life --> Earth
	TradeCD[28582] = 72000		--- Primal Mana --> Fire
	TradeCD[28580] = 72000		--- Primal Shadow --> Water
	TradeCD[28569] = 72000		--- Primal Water --> Air
	TradeCD[28581] = 72000		--- Primal Water --> Shadow
	TradeCD[53777] = 72000		--- Eternal Air --> Earth
	TradeCD[52776] = 72000		--- Eternal Air --> Water
	TradeCD[53781] = 72000		--- Eternal Earth --> Air
	TradeCD[53782] = 72000		--- Eternal Earth --> Shadow
	TradeCD[53775] = 72000		--- Eternal Fire --> Life
	TradeCD[53774] = 72000		--- Eternal Fire --> Water
	TradeCD[53773] = 72000		--- Eternal Life --> Fire
	TradeCD[53771] = 72000		--- Eternal Life --> Shadow
	TradeCD[54020] = 72000		--- Eternal Might
	TradeCD[53779] = 72000		--- Eternal Shadow --> Earth
	TradeCD[52780] = 72000		--- Eternal Shadow --> Life
	TradeCD[53783] = 72000		--- Eternal Water --> Air
	TradeCD[53784] = 72000		--- Eternal Water --> Fire


	--- Other Cooldowns ---
	--Ench--
	TradeCD[28027] = 172800		--- Prismatic Sphere
	TradeCD[28028] = 172800		--- Void Sphere

	--Tailoring--
	TradeCD[56005] = 590400		--- Glacial Bag

	--Alch (hurr durr)--
	TradeCD[60893] = 244800		--- Alchemy Research

local TradeSkill = {}

	--- Item Cooldowns ---
	TradeSkill[44717] = "Item"			--- Disgusting Jar <From Ripe Jar: ID 44718>
	TradeSkill[39878] = "Item"			--- Mysterious Egg <From Cracked Egg: ID 39883>

	--- Transmute Cooldowns and 20 hour CDs ---
	--JC--
	TradeSkill[47280] = "Jewelcrafting"	--- Brilliant Glass
	TradeSkill[62242] = "Jewelcrafting"	--- Icy Prism
	TradeSkill[66658] = "Jewelcrafting"	--- Ametrine
	TradeSkill[66659] = "Jewelcrafting"	--- Cardinal Ruby
	TradeSkill[66662] = "Jewelcrafting"	--- Dreadstone
	TradeSkill[66664] = "Jewelcrafting"	--- Eye of Zul
	TradeSkill[66660] = "Jewelcrafting"	--- King's Amber
	TradeSkill[66663] = "Jewelcrafting"	--- Majestic Zircon

	--Inscription--
	TradeSkill[61288] = "Inscription"	--- Minor Glyph RS
	TradeSkill[61177] = "Inscription"	--- Major Glyph RS

	--Alch--
	TradeSkill[11479] = "Alchemy"		--- Iron --> Gold
	TradeSkill[11480] = "Alchemy"		--- Mithril --> Truesilver
	TradeSkill[17559] = "Alchemy"		--- Air --> Fire
	TradeSkill[17566] = "Alchemy"		--- Earth --> Life
	TradeSkill[17561] = "Alchemy"		--- Earth --> Water
	TradeSkill[17560] = "Alchemy"		--- Fire --> Earth
	TradeSkill[17565] = "Alchemy"		--- Life --> Earth
	TradeSkill[17563] = "Alchemy"		--- Undeath --> Earth
	TradeSkill[17562] = "Alchemy"		--- Water --> Air
	TradeSkill[17564] = "Alchemy"		--- Water --> Undeath
	TradeSkill[28566] = "Alchemy"		--- Primal Air --> Fire
	TradeSkill[28585] = "Alchemy"		--- Primal Earth --> Life
	TradeSkill[28567] = "Alchemy"		--- Primal Earth --> Water
	TradeSkill[28568] = "Alchemy"		--- Primal Fire --> Earth
	TradeSkill[28583] = "Alchemy"		--- Primal Fire --> Mana
	TradeSkill[28584] = "Alchemy"		--- Primal Life --> Earth
	TradeSkill[28582] = "Alchemy"		--- Primal Mana --> Fire
	TradeSkill[28580] = "Alchemy"		--- Primal Shadow --> Water
	TradeSkill[28569] = "Alchemy"		--- Primal Water --> Air
	TradeSkill[28581] = "Alchemy"		--- Primal Water --> Shadow
	TradeSkill[53777] = "Alchemy"		--- Eternal Air --> Earth
	TradeSkill[52776] = "Alchemy"		--- Eternal Air --> Water
	TradeSkill[53781] = "Alchemy"		--- Eternal Earth --> Air
	TradeSkill[53782] = "Alchemy"		--- Eternal Earth --> Shadow
	TradeSkill[53775] = "Alchemy"		--- Eternal Fire --> Life
	TradeSkill[53774] = "Alchemy"		--- Eternal Fire --> Water
	TradeSkill[53773] = "Alchemy"		--- Eternal Life --> Fire
	TradeSkill[53771] = "Alchemy"		--- Eternal Life --> Shadow
	TradeSkill[54020] = "Alchemy"		--- Eternal Might
	TradeSkill[53779] = "Alchemy"		--- Eternal Shadow --> Earth
	TradeSkill[52780] = "Alchemy"		--- Eternal Shadow --> Life
	TradeSkill[53783] = "Alchemy"		--- Eternal Water --> Air
	TradeSkill[53784] = "Alchemy"		--- Eternal Water --> Fire


	--- Other Cooldowns ---
	--Ench--
	TradeSkill[28027] = "Enchanting"	--- Prismatic Sphere
	TradeSkill[28028] = "Enchanting"	--- Void Sphere

	--Tailoring--
	TradeSkill[56005] = "Tailoring"		--- Glacial Bag

	--Alch (hurr durr)--
	TradeSkill[60893] = "Alchemy"		--- Alchemy Research
--[[
for k, v in pairs(TradeCD) do
print(k .. " (" .. TradeSkill[k] .. ") - " .. SecondsToTime(v))
end
]]
	--- Done with cooldown information ---
-------------------
 --- Functions ---
-------------------

-- This is a very useful code snippet I found on WoWWiki's, you guessed it,
-- code snippet section that takes a decimal percent and several rgb values and creates a color.
local function ColorGradient(perc, ...)
if perc then
	if perc >= 1 then
		local r, g, b = select(select('#', ...) - 2, ...)
		return r, g, b
	elseif perc <= 0 then
		local r, g, b = ...
		return r, g, b
	end

	local num = select('#', ...) / 3

	local segment, relperc = math.modf(perc*(num-1))
	local r1, g1, b1, r2, g2, b2 = select((segment*3)+1, ...)

	return r1 + (r2-r1)*relperc, g1 + (g2-g1)*relperc, b1 + (b2-b1)*relperc
end
return 0, 0, 0
end



--- This is what gives the max skinning level and estimated level of your toon according to the skill's level
local function H3S_ProfessionLevel(lvlVAR,nameVAR,plylvlVAR)
local nameVAR = nameVAR or ""
local lvlVAR = lvlVAR or 0

if nameVAR == "Riding" then

if lvlVAR == 75 then
if plylvlVAR > 39 then return 39 else return plylvlVAR end
elseif lvlVAR == 150 then
if plylvlVAR > 59 then return 59 else return plylvlVAR end
elseif lvlVAR == 225 then
if plylvlVAR > 69 then return 69 else return plylvlVAR end
elseif lvlVAR == 300 then
if plylvlVAR > 85 then return 85 else return plylvlVAR end
else
return 0
end

else
if lvlVAR <= 100 then
return floor(lvlVAR/10+10)
elseif (lvlVAR > 100 and lvlVAR <=300) then
return floor(lvlVAR/5)
elseif lvlVAR > 300 and lvlVAR <=450 then
return 60 + floor((lvlVAR-300)/7.5)
else
return 99
end


end
end

-- Takes the "level" and returns the difficulty color using the quest color function.
local function H3S_MobDiffCol(skillLVL)
local skillLVL = tonumber(skillLVL)
	if skillLVL <= 0 then
		skillLVL = -1
	end
	local color = GetQuestDifficultyColor(skillLVL)
	return {color.r * 255, color.g * 255, color.b * 255}
end

---Kind of self-explanatory, but it seperates the server and the name.
function H3S_SepServerName(servername)
if servername then
local server, name = strsplit(" - ", servername, 2)
name = string.sub(name, 3)
return {server, name}
end
return {"nil", "nil"}
end

---Returns a class color based on the given name and the current database values for the class colors---
function H3S_GetClassColor(classVAR)
if classVAR == "DEATHKNIGHT" then return {db.classCol_DEATHKNIGHT[1]*255, db.classCol_DEATHKNIGHT[2]*255, db.classCol_DEATHKNIGHT[3]*255}
elseif classVAR == "DRUID" then return {db.classCol_DRUID[1]*255, db.classCol_DRUID[2]*255, db.classCol_DRUID[3]*255}
elseif classVAR == "HUNTER" then return {db.classCol_HUNTER[1]*255, db.classCol_HUNTER[2]*255, db.classCol_HUNTER[3]*255}
elseif classVAR == "MAGE" then return {db.classCol_MAGE[1]*255, db.classCol_MAGE[2]*255, db.classCol_MAGE[3]*255}
elseif classVAR == "PALADIN" then return {db.classCol_PALADIN[1]*255, db.classCol_PALADIN[2]*255, db.classCol_PALADIN[3]*255}
elseif classVAR == "PRIEST" then return {db.classCol_PRIEST[1]*255, db.classCol_PRIEST[2]*255, db.classCol_PRIEST[3]*255}
elseif classVAR == "ROGUE" then return {db.classCol_ROGUE[1]*255, db.classCol_ROGUE[2]*255, db.classCol_ROGUE[3]*255}
elseif classVAR == "SHAMAN" then return {db.classCol_SHAMAN[1]*255, db.classCol_SHAMAN[2]*255, db.classCol_SHAMAN[3]*255}
elseif classVAR == "WARLOCK" then return {db.classCol_WARLOCK[1]*255, db.classCol_WARLOCK[2]*255, db.classCol_WARLOCK[3]*255}
elseif classVAR == "WARRIOR" then return {db.classCol_WARRIOR[1]*255, db.classCol_WARRIOR[2]*255, db.classCol_WARRIOR[3]*255}
else return {125, 125, 125} end
end

--Skill analysis in chat (Learning how skills are formatted and such.
--for k = 1, GetNumSkillLines() do local v1, v2, _, v3, _, _, v4, _, _, _, _, _, _ = GetSkillLineInfo(k) if not v2 then print(string.format("Skill: %s - %s/%s", v1, v3,v4)) end end
--------------
 --- Hooks ---
--------------
--When our broker module is enabled--
function Broker_H3S:OnEnable()
	self.db = LibStub("AceDB-3.0"):New("Broker_H3SkillsDB", { profile = {
		iconOnly = false,
		showPrimary = true,
		showSecondary = true,
		tooltipFont = GameTooltipText:GetFont(),
		tooltipFontV = "Friz Quadrata TT",
		textSize = 12,
		headerSize = 15,
		nameSize = 14,
		subheaderSize = 13,
		tiphintSize = 10,
		fontScale = 1,
		tooltipHeight = 500,
		defaultNameCol = {130/200,200/200,200/200,1},

		showCooldowns = true,
		groupCDsInToons = true,

		classCol_DEATHKNIGHT = 	{196/255, 	30/255, 	59/255,		1},
		classCol_DRUID = 		{255/255, 	125/255, 	10/255,		1},
		classCol_HUNTER = 		{171/255, 	212/255, 	115/255,	1},
		classCol_MAGE = 		{105/255, 	204/255, 	240/255,	1},
		classCol_PALADIN = 		{255/255, 	150/255, 	196/255,	1},
		classCol_PRIEST = 		{1,			1,			1,			1},
		classCol_ROGUE = 		{255/255, 	245/255, 	105/255,	1},
		classCol_SHAMAN = 		{36/255, 	89/255, 	255/255,	1},
		classCol_WARLOCK = 		{148/255, 	130/255, 	201/255,	1},
		classCol_WARRIOR = 		{199/255, 	156/255, 	110/255,	1},

		classColors = true,
		showSubheaders = false,
		AllToons = false,

		showReady = true,
	}}, "Default")

	--Define database related variables for first-time users.
	db = self.db.profile
	db.IsOnLine = false
	db.SMTextures = {}
	db.SMFonts = {}
	db.snapFrames = true

	--Define variables that might or might not be defined depending on
	--if you are a first time user overall or on current character/server etc.
	if not db.GlobalSkillsTable then db.GlobalSkillsTable = {} end
	if not db.GlobalSkillsTable[GetRealmName()] then db.GlobalSkillsTable[GetRealmName()] = {} end
	if not db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")] then db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")] = {} end
	if not db.CharacterTbl then db.CharacterTbl = {} end
	if not db.CharacterTbl[GetRealmName()] then db.CharacterTbl[GetRealmName()] = {} end
	if not db.RealmTbl then db.RealmTbl = {} end
	if not db.CharacterClasses then db.CharacterClasses = {} end
	if not db.CharacterClasses[GetRealmName()] then db.CharacterClasses[GetRealmName()] = {} end
	if not db.CharacterLevels then db.CharacterLevels = {} end
	if not db.CharacterLevels[GetRealmName()] then db.CharacterLevels[GetRealmName()] = {} end
	if not db.AccountTCDs then db.AccountTCDs = {} end
	if not db.AccountTCDs[GetRealmName()] then db.AccountTCDs[GetRealmName()] = {} end
	if not db.AccountTCDs[GetRealmName()][GetUnitName("player")] then db.AccountTCDs[GetRealmName()][GetUnitName("player")] = {} end
	if not db.ToonHasCD then db.ToonHasCD = {} end
	if not db.ToonHasCD[GetUnitName("player") .. " - " .. GetRealmName()] then db.ToonHasCD[GetUnitName("player") .. " - " .. GetRealmName()] = false end
	db.CharacterLevels[GetRealmName()][GetUnitName("player")] = UnitLevel("player")

	local playerClass, englishClass = UnitClass("player");
	db.CharacterClasses[GetRealmName()][GetUnitName("player")] = englishClass

--Retrieves the toon's name color based on class colors and whether or not they are enabled.
function H3S_RetrieveToonColor(serverVAR,nameVAR)
if db.CharacterClasses[serverVAR][nameVAR] and db.classColors then return H3S_GetClassColor(db.CharacterClasses[serverVAR][nameVAR])
else return {db.defaultNameCol[1]*255, db.defaultNameCol[2]*255, db.defaultNameCol[3]*255} end
end

--Retrieves the level of the toon to use in the names.--
function H3S_RetrieveToonLevel(serverVAR,nameVAR)
if db.CharacterLevels[serverVAR][nameVAR] then return db.CharacterLevels[serverVAR][nameVAR]
else return 0 end
end


-------Update cooldowns >.>-------
function H3S_UpdateCooldowns()
-- This is where we check for cooldowns, update them, etc.
--------------------------------------------------------------------------------------
--------------------------------CURRENT DATA FORMATING--------------------------------
------{name, 	character, 	id,		unlocked, 	time, 	datesaved, 	cooldown}	------
------{string,	string,   	numb,	bool,     	num,  	num,       	string}		------
--------------------------------------------------------------------------------------
--[[
for k, v in pairs(TradeCD) do
print(k .. " - " .. v)
end
]]

for k, v in pairs(TradeCD) do
if select(1, GetSpellCooldown(k)) > 0 then
--print("lol")
db.AccountTCDs[GetRealmName()][GetUnitName("player")][select(1, GetSpellInfo(k))] = {select(1, GetSpellInfo(k)), GetUnitName("player"), k, false,  TradeCD[k] - (GetTime() - select(1, GetSpellCooldown(k))), time()}
end
end

if db.AccountTCDs[GetRealmName()] then
for v,_ in pairs(db.AccountTCDs[GetRealmName()]) do
db.ToonHasCD[v .. " - " .. GetRealmName()] = false
for k, _ in pairs(db.AccountTCDs[GetRealmName()][v]) do
if db.AccountTCDs[GetRealmName()][v][k] then
local name, character, id, unlocked, unlockTime, dateSaved = unpack(db.AccountTCDs[GetRealmName()][v][k])

unlockTime, dateSaved = unlockTime - (time() - dateSaved), time() -- Update unlockTime and dateSaved so this isn't pointless.
if unlockTime > 0 then
	unlocked = false
elseif unlocked == false then
	print(string.format("|cff%02x%02x%02x%s|r %s's %q is now ready!",130,130,200,"H3Skills",character,name))
	unlocked = true
end
if not unlocked then
db.ToonHasCD[v .. " - " .. GetRealmName()] = true
end
db.AccountTCDs[GetRealmName()][v][name] = {name, character, id, unlocked, unlockTime, dateSaved}
end
end -- end for loop
end
else return end
end
--End update cooldowns--


---Add skill lines---
for k, v in pairs(db.AccountTCDs[GetRealmName()][GetUnitName("player")]) do
print(unpack(v))
end

function H3S_SetupCooldowns(toonName)
	if db.showCooldowns and toonName == "ALL TOONS" then
		for i=1, #(db.CharacterTbl[GetRealmName()]) do
				if db.AccountTCDs[GetRealmName()][db.CharacterTbl[GetRealmName()][i]] then
				local TCDLoopLine = 0
				for k, v in pairs(db.AccountTCDs[GetRealmName()][db.CharacterTbl[GetRealmName()][i]]) do
				TCDLoopLine = TCDLoopLine + 1
				--print(unpack(v))
					local name, character, id, unlocked, unlockTime, dateSaved = unpack(v)
					if TCDLoopLine == 1 and (db.ToonHasCD[character .. " - " .. GetRealmName()] or db.showReady)  then
					local placeHolder = tooltip:AddLine(" ")
					local r,g,b = unpack(H3S_RetrieveToonColor(GetRealmName(),character))
					tooltip:SetCell(placeHolder, 1, string.format("|cff%02x%02x%02x%s",r,g,b,character .. " (lvl " .. H3S_RetrieveToonLevel(GetRealmName(),character) .. ")"), textFont, "CENTER", tooltip:GetColumnCount())
					end

					local r,g,b = ColorGradient(unlockTime/TradeCD[id], 0,1,0, 1,1,0, 1,0,0)
					--print(unlockTime .. " - " .. TradeCD[id] .. " - " .. unlockTime/TradeCD[id])
					r,g,b = r*255,g*255,b*255
					if not unlocked then
						tooltip:AddLine(name,'',string.format("|cff%02x%02x%02x%s",r,g,b,SecondsToTime(unlockTime)))
					elseif unlocked and db.showReady then
						tooltip:AddLine(name,'',string.format("|cff%02x%02x%02x%s",r,g,b,"Ready!"))
					end

				end
				end
		end -- End for realm loop

	elseif db.showCooldowns and (not (toonName == "ALL TOONS")) then
		if db.AccountTCDs[GetRealmName()][toonName] then
		for k, v in pairs(db.AccountTCDs[GetRealmName()][toonName]) do
		--print(unpack(v))
			local name, character, id, unlocked, unlockTime, dateSaved = unpack(v)
			local r,g,b = ColorGradient(unlockTime/TradeCD[id], 0,1,0, 1,1,0, 1,0,0)
			r,g,b = r*255,g*255,b*255
				if not unlocked then
					tooltip:AddLine(name,'',string.format("|cff%02x%02x%02x%s",r,g,b,SecondsToTime(unlockTime)))
				elseif unlocked and db.showReady then
					tooltip:AddLine(name,'',string.format("|cff%02x%02x%02x%s",r,g,b,"Ready!"))
				end

		end
		end

	else
		return
	end
end

	--db.CharacterTbl = {}
	--db.CharacterTbl[GetRealmName()] = {}
	--db.RealmTbl = {}
	--Setup our config tables from shared media. By defining it once in our own database, we don't have to keep
	--accessing other databases, and it's much faster to type db.SMFonts["DorisPP"] than
	--LibStub:GetLibrary("LibSharedMedia-3.0"):Fetch("font", "DorisPP", false)
	for k, v in pairs(LibStub:GetLibrary("LibSharedMedia-3.0"):List("statusbar")) do
	db.SMTextures[v] = LibStub:GetLibrary("LibSharedMedia-3.0"):Fetch("statusbar", v, false)
	end
	for k, v in pairs(LibStub:GetLibrary("LibSharedMedia-3.0"):List("font")) do
	db.SMFonts[v] = LibStub:GetLibrary("LibSharedMedia-3.0"):Fetch("font", v, false)
	end

--Code snippet to hide the tooltip when your mouse is off the tooltip.
function H3S_hidett(self, elapsed2)
	totaltime2 = totaltime2 + elapsed2
	if totaltime2 > 0.05 then
		totaltime2 = 0
		if tooltip and (not MouseIsOver(tooltip)) and db.IsOnLine == false then
			tooltip:SetScript("OnEnter", nil)
			tooltip:SetScript("OnLeave", nil)
			LibQTip:Release(tooltip)
			tooltip = nil
			H3S_2:SetScript("OnUpdate", nil)
		elseif not tooltip then
			H3S_2:SetScript("OnUpdate", nil)
		end
	end
end

	LibStub("AceConfig-3.0"):RegisterOptionsTable("Broker_H3Skills", {
		name = "Broker H3 Skills", type = "group",
		get = function(key) return db[key.arg] end,
		set = function(key, value) db[key.arg] = value end,
		args = {
			header1 = { name = "Basic Options", type = "header", order = 1 },
			iconOnly = {
				name = "Icon Only",
				type = "toggle", order = 2, arg = "iconOnly",
				get = function(key) return db[key.arg] end,
				set = function(key, value) db[key.arg] = value
					if value then
					H3S_Object.text = ""
					else
					H3S_Object.text = "H3 Skills"
					end
				end
			},
			showSubheaders = {
				name = "Show Subheaders",
				type = "toggle", order = 3, arg = "showSubheaders",
			},
			showPrimary = {
				name = "Primary Skills",
				type = "toggle", order = 4, arg = "showPrimary",
			},
			showSecondary = {
				name = "Secondary Skills",
				type = "toggle", order = 5, arg = "showSecondary",
			},
			AllToons = {
				name = "All Characters (on server)",
				type = "toggle", order = 6, arg = "AllToons", width = 'full',
			},
			showCooldowns = {
				name = "Show Tradeskill Cooldowns", width = 'full',
				type = "toggle", order = 7, arg = "showCooldowns",
			},
			groupCDsInToons = {
				name = "Group Cooldowns in toon sections", width = 'full',
				type = "toggle", order = 8, arg = "groupCDsInToons",
			},
			showReady = {
				name = "Show ready used Tradeskills", width = 'full',
				type = "toggle", order = 9, arg = "showReady",
			},


			header2 = { name = "Font Options", type = "header", order = 10 },
			tooltipFont = {
				name = "Tooltip Font",
				type = 'select', dialogControl = 'LSM30_Font', order = 11, arg = "tooltipFontV", width = 'full',
				values = db.SMFonts,
				get = function(key) return db[key.arg] end,
				set = function(key, value) db[key.arg] = value   db.tooltipFont = db.SMFonts[value] end
			},
			tooltipHeight = {
				name = "Tooltip Height (Max)",
				type = "range", order = 12,  min = 100, max = 2000, bigStep = 10, arg = "tooltipHeight", width = 'full',
				},
			fontScale = {
				name = "Font Scale",
				type = "range", order = 13,  min = 0.5, max = 2, bigStep = 0.05, arg = "fontScale", width = 'full',
				},
			textSize = {
				name = "Text Size",
				type = "range", order = 14,  min = 5, max = 30, bigStep = 1, arg = "textSize",
				},
			headerSize = {
				name = "Header Size",
				type = "range", order = 15,  min = 5, max = 30, bigStep = 1, arg = "headerSize",
				},
			nameSize = {
				name = "Name Size",
				type = "range", order = 16,  min = 5, max = 30, bigStep = 1, arg = "nameSize",
				},
			subheaderSize = {
				name = "Sub-header Size",
				type = "range", order = 17,  min = 5, max = 30, bigStep = 1, arg = "subheaderSize",
				},
			tiphintSize = {
				name = "Hint Size",
				type = "range", order = 18,  min = 5, max = 30, bigStep = 1, arg = "tiphintSize",
				},
			resetTextOptions = {
				name = "Reset Text Settings",
				type = "execute", order = 19, func = function()
						db.textSize = 12
						db.headerSize = 15
						db.nameSize = 14
						db.subheaderSize = 13
						db.tiphintSize = 10
						db.fontScale = 1
						end,
				},

			header3 = { name = "Color Options", type = "header", order = 20 },
			classColors = {
				name = "Color Name by Class Colors",
				type = "toggle", order = 21, arg = "classColors", width = 'full',
			},
			defaultNameCol = {
				name = "Default Name Color",
 				type = "color", order = 22, hasAlpha = false, --width = 'double',
                   get = function(info) return unpack(db.defaultNameCol) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.defaultNameCol
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetDefaultNameCol = {
				name = "Reset", --width = 'double',
				type = "execute", order = 23, func = function()
						db.defaultNameCol = {130/200,200/200,200/200,1}
				end,
				},



			classCol_DEATHKNIGHT = {
				name = "Death Knight Color",
 				type = "color", order = 24, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_DEATHKNIGHT) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_DEATHKNIGHT
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_DEATHKNIGHT = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 25, func = function()
						db.classCol_DEATHKNIGHT = {196/255, 30/255, 59/255,	1}
				end,
				},



			classCol_DRUID = {
				name = "Druid Color",
 				type = "color", order = 26, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_DRUID) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_DRUID
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_DRUID = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 27, func = function()

						db.classCol_DRUID = {255/255, 125/255, 10/255, 1}
				end,
				},



			classCol_HUNTER = {
				name = "Hunter Color",
 				type = "color", order = 28, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_HUNTER) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_HUNTER
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_HUNTER = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 29, func = function()

						db.classCol_HUNTER = {171/255, 	212/255, 	115/255,	1}
				end,
				},



			classCol_MAGE = {
				name = "Mage Color",
 				type = "color", order = 30, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_MAGE) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_MAGE
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_MAGE = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 31, func = function()

						db.classCol_MAGE = {105/255, 	204/255, 	240/255,	1}
				end,
				},



			classCol_PALADIN = {
				name = "Paladin Color",
 				type = "color", order = 32, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_PALADIN) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_PALADIN
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_PALADIN = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 33, func = function()

						db.classCol_PALADIN = {255/255, 	150/255, 	196/255,	1}
				end,
				},



			classCol_PRIEST = {
				name = "Priest Color",
 				type = "color", order = 34, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_PRIEST) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_PRIEST
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_PRIEST = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 35, func = function()

						db.classCol_PRIEST = {1,			1,			1,			1}
				end,
				},



			classCol_ROGUE = {
				name = "Rogue Color",
 				type = "color", order = 36, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_ROGUE) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_ROGUE
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_ROGUE = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 37, func = function()

						db.classCol_ROGUE = {255/255, 	245/255, 	105/255,	1}
				end,
				},



			classCol_SHAMAN = {
				name = "Shaman Color",
 				type = "color", order = 38, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_SHAMAN) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_SHAMAN
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_SHAMAN = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 39, func = function()

						db.classCol_SHAMAN = {36/255, 	89/255, 	255/255,	1}
				end,
				},



			classCol_WARLOCK = {
				name = "Warlock Color",
 				type = "color", order = 40, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_WARLOCK) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_WARLOCK
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_WARLOCK = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 41, func = function()

						db.classCol_WARLOCK = {148/255, 	130/255, 	201/255,	1}
				end,
				},



			classCol_WARRIOR = {
				name = "Warrior Color",
 				type = "color", order = 42, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_WARRIOR) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_WARRIOR
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_WARRIOR = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 43, func = function()

						db.classCol_WARRIOR = {199/255, 	156/255, 	110/255,	1}
				end,
				},


			header4 = { name = "Datatable Options", type = "header", order = 44 },

			clearCDTable = {
				name = "Clear Cooldown Table", width = 'full',
				type = "execute", order = 45, func = function()
					db.AccountTCDs = {}
					if not db.AccountTCDs[GetRealmName()] then db.AccountTCDs[GetRealmName()] = {} end
					if not db.AccountTCDs[GetRealmName()][GetUnitName("player")] then db.AccountTCDs[GetRealmName()][GetUnitName("player")] = {} end
					print(string.format("|cff%02x%02x%02x%s|r The cooldowns database has been cleared.",130,130,200,"H3Skills"))
					db.ToonHasCD = {}
					db.ToonHasCD[GetUnitName("player") .. " - " ..  GetRealmName()] = false
				end,
				},

				--Functions for testing purposes. Should never be enabled on official builds.
			--[[
			DEBUGFUNC2 = {
				name = "TEST DATA",
				type = "execute", order = 28, func = function()

				print(unpack(db.CharacterTbl[GetRealmName()]))


				end,
				},
			]]

		},
	})

	--Add to blizzard options for those tho don't want the standalone config for some reason--
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker_H3Skills", "Broker H3 Skills")

	--Create our standalone configuration using the config made above.
    LibStub("AceConfigDialog-3.0"):SetDefaultSize("Broker_H3Skills", 400, 600)

	--Create slash commands to open the standalone config
	_G.SlashCmdList["H3S"] = function() LibStub("AceConfigDialog-3.0"):Open("Broker_H3Skills") end
	_G["SLASH_H3S1"] = "/brokerh3s"
	_G["SLASH_H3S2"] = "/h3skills"
	_G["SLASH_H3S3"] = "/h3skill"
	_G["SLASH_H3S4"] = "/h3s"

end



---Upon entering the module's object on the broker bar---
function H3S_Object.OnEnter(self)

	 -- Turn the tooltip into a QTip tooltip to make formatting easier. --
	tooltip = LibQTip:Acquire("Broker_H3Skills", 3, "LEFT", "CENTER", "RIGHT")

	 -- Setup hooks for the tooltip so it doesn't sit there forever. --
	H3S_2:SetScript("OnUpdate", nil)
	tooltip:SetScript("OnEnter", function(self) H3S_2:SetScript("OnUpdate", nil) end)
	tooltip:SetScript("OnLeave", function(self) H3S_2:SetScript("OnUpdate", H3S_hidett) end)
	tooltip:SmartAnchorTo(self)
	tooltip:Clear()

   self.tooltip = tooltip

 -- Setup our fonts --
local tiphintFont = CreateFont("Broker_H3SkillsFont-11")
tiphintFont:SetFont(db.tooltipFont, db.tiphintSize*db.fontScale)

local textFont = CreateFont("Broker_H3SkillsFont-12")
textFont:SetFont(db.tooltipFont, db.textSize*db.fontScale)

local subheaderFont = CreateFont("Broker_H3SkillsFont-13")
subheaderFont:SetFont(db.tooltipFont, db.subheaderSize*db.fontScale)

local nameFont = CreateFont("Broker_H3SkillsFont-14")
nameFont:SetFont(db.tooltipFont, db.nameSize*db.fontScale)

local headerFont = CreateFont("Broker_H3SkillsFont-15")
headerFont:SetFont(db.tooltipFont, db.headerSize*db.fontScale)


--- Set tooltip fonts to ours instead of using the regular game font. ---
tooltip:SetHeaderFont(headerFont)
tooltip:SetFont(textFont)
	tooltip:AddHeader("Name","Level","Rank")

--- Always place a placeholder before setting a cell, otherwise it will ---
---   just use the current one and overwrite anything that was there.   ---

--Primary and Secondary skill tables for current toon.
local CTProfTblPri = {}
local CTProfTblSec = {}

	if #(db.CharacterTbl[GetRealmName()]) > 1 then
	table.sort(db.CharacterTbl[GetRealmName()],function(a,b) return string.lower(a) < string.lower(b) end)
	end

	if #(db.RealmTbl) > 1 then
	table.sort(db.RealmTbl,function(a,b) return string.lower(a) < string.lower(b) end)
	end


-- A for loop to create the tooltip for current character and update the datatable for current character. --
if db.AllToons then

--Loop to define variables for current toon---
local curHeader = ""
for skillIndex = 1, GetNumSkillLines() do
  --Define variables
  local skillName, isHeader, isExpanded, skillRank, numTempPoints, skillModifier,
    skillMaxRank, isAbandonable, stepCost, rankCost, minLevel, skillCostType,
    skillDescription = GetSkillLineInfo(skillIndex)
  if skillName == "Lockpicking" then
    db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Lockpicking = {skillName,skillRank,skillMaxRank,H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))),H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player")))}
  end

  -- If it is a primary or secondary profession, then..
  if not isHeader and ((curHeader == "Professions" and db.showPrimary == true) or (curHeader == "Secondary Skills" and db.showSecondary == true)) then
  if curHeader == "Professions" then CTProfTblPri[#CTProfTblPri+1] = {skillName,skillRank,skillMaxRank,H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))),H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player")))} end
  if curHeader == "Secondary Skills" then CTProfTblSec[#CTProfTblSec+1] = {skillName,skillRank,skillMaxRank,H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))),H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player")))} end
  else -- If it's a header
  -- Set our header so the next step in the loop will be able to add to the tooltip if it's a Primary or Secondary skill.
  curHeader = skillName
  -- If our header is Primary or Secondary skills, create a header for it.
  end
end

	--place the table in global skills table for our toon
	--Add our tables to the global skills table--
	if #CTProfTblPri > 0 then
		db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Primary   = CTProfTblPri
	else
		db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Primary   = nil
	end

	if #CTProfTblSec > 0 then
		db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Secondary = CTProfTblSec
	else
		db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Secondary = nil
	end

	---Setup Character and Realm lists.---
	if #CTProfTblPri > 0 or #CTProfTblSec > 0 then
		local exists = false
		for k = 1, #(db.CharacterTbl[GetRealmName()]) do
			if db.CharacterTbl[GetRealmName()][k] == GetUnitName("player") then exists = true end
		end
		if exists == false then
		db.CharacterTbl[GetRealmName()][#(db.CharacterTbl[GetRealmName()])+1] = GetUnitName("player")
		end
	--for k=1, #db.AccountCharacters do
	--db.AccountCharacterList[db.AccountCharacters[k]] = db.AccountCharacters[k]
	--end
		local exists = false
		for k = 1, #(db.RealmTbl) do
			if db.RealmTbl[k] == GetRealmName() then exists = true end
		end
		if exists == false then
			db.RealmTbl[#(db.RealmTbl)+1] = GetRealmName()
		end
	end


---Draw our tooltip---
for v=1, #(db.CharacterTbl[GetRealmName()]) do
---Define our primary and secondary tables---
	local PrimaryTbl = db.GlobalSkillsTable[GetRealmName()][db.CharacterTbl[GetRealmName()][v]].Primary
	local SecondaryTbl = db.GlobalSkillsTable[GetRealmName()][db.CharacterTbl[GetRealmName()][v]].Secondary
	--Name Header--
	if (db.showPrimary and PrimaryTbl) or (db.showSecondary and SecondaryTbl) or (db.showCooldowns and db.groupCDsInToons and db.ToonHasCD[db.CharacterTbl[GetRealmName()][v] .. " - " .. GetRealmName()]) then
		---Seperators make the tooltip easily read---
		tooltip:AddSeparator(2, 255, 255, 255)
		local placeHolder = tooltip:AddLine(" ")
		local r,g,b = unpack(H3S_RetrieveToonColor(GetRealmName(),db.CharacterTbl[GetRealmName()][v]))
		tooltip:SetCell(placeHolder, 1, string.format("|cff%02x%02x%02x%s",r,g,b,db.CharacterTbl[GetRealmName()][v] .. " (lvl " .. H3S_RetrieveToonLevel(GetRealmName(),db.CharacterTbl[GetRealmName()][v]) .. ")"), nameFont, "CENTER", tooltip:GetColumnCount())
		---Show lockpicking so you dont have to go into the skills window manually to see it---
		if db.GlobalSkillsTable[GetRealmName()][db.CharacterTbl[GetRealmName()][v]].Lockpicking then
			local skillName, skillRank, skillMaxRank, skillCol, skillCol2 = unpack(db.GlobalSkillsTable[GetRealmName()][db.CharacterTbl[GetRealmName()][v]].Lockpicking)
			local skillCol = skillCol or {0,0,0}
			local skillCol2 = skillCol2 or {0,0,0}
			local r,g,b = ColorGradient(skillRank/skillMaxRank, 1,0,0, 1,1,0, 0,1,0)
			r,g,b = r*255,g*255,b*255
			local r2,g2,b2 = unpack(skillCol)
			tooltip:AddLine(skillName,string.format("|cff%02x%02x%02x%d",r2,g2,b2,H3S_ProfessionLevel(skillRank,skillName,H3S_RetrieveToonLevel(GetRealmName(),db.CharacterTbl[GetRealmName()][v]))),string.format("|cff%02x%02x%02x%s/%s",r,g,b,skillRank,skillMaxRank))
		end
	end
	--Draw primary table info--
	if db.showPrimary and PrimaryTbl then
	  if db.showSubheaders then
		local placeHolder = tooltip:AddLine(" ")
		tooltip:SetCell(placeHolder, 1, "Professions", subheaderFont, "CENTER", tooltip:GetColumnCount())
	  end
		for k=1, #PrimaryTbl do
		local skillName, skillRank, skillMaxRank, skillCol, skillCol2 = unpack(PrimaryTbl[k])
		local skillCol = skillCol or {0,0,0}
		local skillCol2 = skillCol2 or {0,0,0}

		local r,g,b = ColorGradient(skillRank/skillMaxRank, 1,0,0, 1,1,0, 0,1,0)
		r,g,b = r*255,g*255,b*255
		local r2,g2,b2 = unpack(skillCol)
		tooltip:AddLine(skillName,string.format("|cff%02x%02x%02x%d",r2,g2,b2,H3S_ProfessionLevel(skillRank,skillName,H3S_RetrieveToonLevel(GetRealmName(),db.CharacterTbl[GetRealmName()][v]))),string.format("|cff%02x%02x%02x%s/%s",r,g,b,skillRank,skillMaxRank))
		end
	end

	--Draw secondary table info--
	if db.showSecondary and SecondaryTbl then
	  if db.showSubheaders then
		local placeHolder = tooltip:AddLine(" ")
		tooltip:SetCell(placeHolder, 1, "Secondary Skills", subheaderFont, "CENTER", tooltip:GetColumnCount())
	  end
		for k=1, #SecondaryTbl do
		local skillName, skillRank, skillMaxRank, skillCol, skillCol2 = unpack(SecondaryTbl[k])
		local skillCol = skillCol or {0,0,0}
		local skillCol2 = skillCol2 or {0,0,0}

		local r,g,b = ColorGradient(skillRank/skillMaxRank, 1,0,0, 1,1,0, 0,1,0)
		r,g,b = r*255,g*255,b*255
		local r2,g2,b2 = unpack(skillCol)
		tooltip:AddLine(skillName,string.format("|cff%02x%02x%02x%d",r2,g2,b2,H3S_ProfessionLevel(skillRank,skillName,H3S_RetrieveToonLevel(GetRealmName(),db.CharacterTbl[GetRealmName()][v]))),string.format("|cff%02x%02x%02x%s/%s",r,g,b,skillRank,skillMaxRank))
		end
	end

	if db.showCooldowns and db.groupCDsInToons then
		H3S_SetupCooldowns(db.CharacterTbl[GetRealmName()][v])
	end

	if v == #(db.CharacterTbl[GetRealmName()]) then
		tooltip:AddSeparator(2, 255, 255, 255)
	end
end

	if db.showCooldowns and (not db.groupCDsInToons)then
		H3S_SetupCooldowns("ALL TOONS")
	end

else
local curHeader = ""
	for skillIndex = 1, GetNumSkillLines() do
	  --Define variables
	  local skillName, isHeader, isExpanded, skillRank, numTempPoints, skillModifier,
		skillMaxRank, isAbandonable, stepCost, rankCost, minLevel, skillCostType,
		skillDescription = GetSkillLineInfo(skillIndex)
		--show lockpicking on the tooltip--
	  if skillName == "Lockpicking" then
		db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Lockpicking = {skillName,skillRank,skillMaxRank,H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))),H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player")))}
		local r,g,b = ColorGradient(skillRank/skillMaxRank, 1,0,0, 1,1,0, 0,1,0)
		r,g,b = r*255,g*255,b*255
		local r2,g2,b2 = unpack(H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))))
		tooltip:AddLine(skillName,string.format("|cff%02x%02x%02x%d",r2,g2,b2,H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))),string.format("|cff%02x%02x%02x%s/%s",r,g,b,skillRank,skillMaxRank))
	  end
	  -- If it is a primary or secondary profession, then..
	  if not isHeader and ((curHeader == "Professions" and db.showPrimary == true) or (curHeader == "Secondary Skills" and db.showSecondary == true)) then
			local r,g,b = ColorGradient(skillRank/skillMaxRank, 1,0,0, 1,1,0, 0,1,0)
			r,g,b = r*255,g*255,b*255
		  --Add data to our current character tables according to
			if curHeader == "Professions" then CTProfTblPri[#CTProfTblPri+1] = {skillName,skillRank,skillMaxRank,H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))),H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player")))} end
			if curHeader == "Secondary Skills" then CTProfTblSec[#CTProfTblSec+1] = {skillName,skillRank,skillMaxRank,H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))),H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player")))} end
			local r2,g2,b2 = unpack(H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))))
			tooltip:AddLine(skillName,string.format("|cff%02x%02x%02x%d",r2,g2,b2,H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))),string.format("|cff%02x%02x%02x%s/%s",r,g,b,skillRank,skillMaxRank))

	  else -- If it's a header
		  -- Set our header so the next step in the loop will be able to add to the tooltip if it's a Primary or Secondary skill.
			curHeader = skillName
		  -- If our header is Primary or Secondary skills, create a header for it.
		  if ((curHeader == "Professions" and db.showPrimary == true) or (curHeader == "Secondary Skills" and db.showSecondary == true)) and db.showSubheaders then
			local placeHolder = tooltip:AddLine(" ")
			tooltip:SetCell(placeHolder, 1, curHeader, subheaderFont, "CENTER", tooltip:GetColumnCount())
		  end
	  end
	end

	--Add our tables to the global skills table--
	if #CTProfTblPri > 0 then
		db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Primary   = CTProfTblPri
	else
		db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Primary   = nil
	end

	if #CTProfTblSec > 0 then
		db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Secondary = CTProfTblSec
	else
		db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Secondary = nil
	end

	---Setup Character and Realm lists.---
	if #CTProfTblPri > 0 or #CTProfTblSec > 0 then
		local exists = false
		for k = 1, #(db.CharacterTbl[GetRealmName()]) do
			if db.CharacterTbl[GetRealmName()][k] == GetUnitName("player") then exists = true end
		end
		if exists == false then
		db.CharacterTbl[GetRealmName()][#(db.CharacterTbl[GetRealmName()])+1] = GetUnitName("player")
		end
	--for k=1, #db.AccountCharacters do
	--db.AccountCharacterList[db.AccountCharacters[k]] = db.AccountCharacters[k]
	--end
		local exists = false
		for k = 1, #(db.RealmTbl) do
			if db.RealmTbl[k] == GetRealmName() then exists = true end
		end
		if exists == false then
			db.RealmTbl[#(db.RealmTbl)+1] = GetRealmName()
		end
	end
if db.showCooldowns then
H3S_SetupCooldowns("ALL TOONS")
end
end --- If alltoons then else end
--Update the character list to allow this to be possible to select.

--Pally Shaman DK Priest
--
-- Add hints to the bottom of the tooltip after we are done.

tooltip:AddLine(" ")
local placeHolder = tooltip:AddLine(" ")
tooltip:SetCell(placeHolder, 1, string.format("|cffeda55f%s |cff%02x%02x%02x%s","Left-Click", 50,255,50," - Options menu."), tiphintFont, "LEFT", tooltip:GetColumnCount())


  --"Smart-Anchor" the tooltip to the object (H3S_Object), aligning the tooltip
  --horizontally and vertically according to the objects position
  tooltip:SmartAnchorTo(self)


	---Show the tooltip, enable the mouse, and limit the tooltips height for those at small resolutions
	--(or those who have ALOT of characters :P)--
    tooltip:Show()
	tooltip:EnableMouse(true)
    tooltip:UpdateScrolling(db.tooltipHeight)
end

--Hide the tooltip when we leave it (after half a second)--
function H3S_Object.OnLeave(self)
	if tooltip and tooltip:IsVisible() then
		--H3S_wait(2.5,H3S_2:SetScript("OnUpdate", H3S_hidett));
		H3S_2:SetScript("OnUpdate", H3S_hidett)
	end

end


--Update variables that need to be updated every "TOTALTIME" seconds (in this case, 5).
H3S:SetScript('OnUpdate', function(self, elap)
	elapsed = elapsed + elap
if elapsed < TOTALTIME then return end
if db.iconOnly == true then
H3S_Object.text = ""
else
H3S_Object.text = "H3 Skills"
end

	db.CharacterLevels[GetRealmName()][GetUnitName("player")] = UnitLevel("player")

	local playerClass, englishClass = UnitClass("player");
	db.CharacterClasses[GetRealmName()][GetUnitName("player")] = englishClass

local CTProfTblPri = {}
local CTProfTblSec = {}

for skillIndex = 1, GetNumSkillLines() do
  --Define variables
  local skillName, isHeader, isExpanded, skillRank, numTempPoints, skillModifier,
    skillMaxRank, isAbandonable, stepCost, rankCost, minLevel, skillCostType,
    skillDescription = GetSkillLineInfo(skillIndex)
  if skillName == "Lockpicking" then
    db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Lockpicking = {skillName,skillRank,skillMaxRank,H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))),H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player")))}
  end

  -- If it is a primary or secondary profession, then..
  if not isHeader and ((curHeader == "Professions" and db.showPrimary == true) or (curHeader == "Secondary Skills" and db.showSecondary == true)) then
  if curHeader == "Professions" then CTProfTblPri[#CTProfTblPri+1] = {skillName,skillRank,skillMaxRank,H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))),H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player")))} end
  if curHeader == "Secondary Skills" then CTProfTblSec[#CTProfTblSec+1] = {skillName,skillRank,skillMaxRank,H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player"))),H3S_MobDiffCol(H3S_ProfessionLevel(skillRank,skillName,UnitLevel("player")))} end
  else -- If it's a header
  -- Set our header so the next step in the loop will be able to add to the tooltip if it's a Primary or Secondary skill.
  curHeader = skillName
  -- If our header is Primary or Secondary skills, create a header for it.
  end
end

	--place the table in global skills table for our toon
	if #CTProfTblPri > 0 then
	db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Primary   = CTProfTblPri
	else
	db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Primary   = nil
	end

	if #CTProfTblSec > 0 then
	db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Secondary = CTProfTblSec
	else
	db.GlobalSkillsTable[GetRealmName()][GetUnitName("player")].Secondary = nil
	end

	---Setup Character and Realm lists.---
	if #CTProfTblPri > 0 or #CTProfTblSec > 0 then
	local exists = false
	for k = 1, #(db.CharacterTbl[GetRealmName()]) do
	if db.CharacterTbl[GetRealmName()][k] == GetUnitName("player") then exists = true end
	end
	if exists == false then
	db.CharacterTbl[GetRealmName()][#(db.CharacterTbl[GetRealmName()])+1] = GetUnitName("player")
	end
	--for k=1, #db.AccountCharacters do
	--db.AccountCharacterList[db.AccountCharacters[k]] = db.AccountCharacters[k]
	--end
	local exists = false
	for k = 1, #(db.RealmTbl) do
	if db.RealmTbl[k] == GetRealmName() then exists = true end
	end
	if exists == false then
	db.RealmTbl[#(db.RealmTbl)+1] = GetRealmName()
	end
	end





H3S_UpdateCooldowns()
elapsed = 0
collectgarbage()
end)


--Open the options menu or do other things when we click the object.
function H3S_Object.OnClick(self, button)
if button == "LeftButton" then
--Use AceConfig's 'standalone' menu.
LibStub("AceConfigDialog-3.0"):Open("Broker_H3Skills")
end
end


function H3S_DEBUGFUNC()
for k, v in pairs(db.AccountTCDs[GetRealmName()][GetUnitName("player")]) do
print(unpack(v))
end
end
